function this = improve_vq( this )

% this = improve_vq( this )
%
% Tries to improve the current vq model by continuing vq adaptation.
% Note: the model should have a precomputed model when calling this method!


%  This file is a part of the Independent Variable Group Analysis package
% 
%  Copyright (C) 2001-2006 Esa Alhoniemi, Antti Honkela, Krista Lagus,
%  Jeremias Seppa, Harri Valpola, and Paul Wagner
% 
%  This program is free software; you can redistribute it and/or modify
%  it under the terms of the GNU General Public License as published by
%  the Free Software Foundation; either version 2, or (at your option)
%  any later version.
% 
%  This program is distributed in the hope that it will be useful,
%  but WITHOUT ANY WARRANTY; without even the implied warranty of
%  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%  GNU General Public License (included in file License.txt in the
%  program package) for more details.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
global State;

if isempty( this.vq.params )
  error( 'mdl_vq_real_nominal.improve_vq(): No precomputed vq model!' );
end


% continue vq adaptation
this.vq = vq( State.data, ...
              'vars', this.vars, ...
              'params', this.vq, ...
              'iters', this.s.iters, ...
              'check', this.s.check, ...
	      'implicit_noisevar', this.s.implicit_noisevar);

this.train.iters = this.train.iters + this.s.iters;

return;
