function safe_append( safe_append_filename, ...
                      safe_append_varname, safe_append_varvalue )

% safe_append( filename, varname, varvalue )


%  This file is a part of the Independent Variable Group Analysis package
% 
%  Copyright (C) 2001-2006 Esa Alhoniemi, Antti Honkela, Krista Lagus,
%  Jeremias Seppa, Harri Valpola, and Paul Wagner
% 
%  This program is free software; you can redistribute it and/or modify
%  it under the terms of the GNU General Public License as published by
%  the Free Software Foundation; either version 2, or (at your option)
%  any later version.
% 
%  This program is distributed in the hope that it will be useful,
%  but WITHOUT ANY WARRANTY; without even the implied warranty of
%  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%  GNU General Public License (included in file License.txt in the
%  program package) for more details.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% remove .mat extension if one exists
if length(safe_append_filename) >= 4 && ...
      strcmp( '.mat', safe_append_filename(end-3:end) )
  safe_append_filename(end-3:end) = [];
end

% prepare the variable
eval([ safe_append_varname ' = safe_append_varvalue;' ]);

% cp 'target' to 'safeappend_bak'. abort if errors.
if ~copyfile( [safe_append_filename '.mat'], ...
              [safe_append_filename '_safeappend_bak.mat'] )
  error( 'Error while backing up the target file!' );
end

% append the variable into 'safeappend_bak'. abort if errors.
save( [safe_append_filename '_safeappend_bak.mat'], safe_append_varname, ...
      '-append' );

% mv 'safeappend_bak' to 'target'. abort if errors.
if ~movefile( [safe_append_filename '_safeappend_bak.mat'], ...
              [safe_append_filename '.mat'] )
  error( 'Error while renaming the backup file!' );
end

return;
