function cost = total_cost( State, inds )

% cost = total_cost( State, [inds] )
%
% State   current grouping
% inds    indices of groups to be included. if omitted, all active groups
%         will be included.
%
% Calculates the total cost for the groups pointed in 'inds', or all active
% groups if 'inds' is omitted.


%  This file is a part of the Independent Variable Group Analysis package
% 
%  Copyright (C) 2001-2006 Esa Alhoniemi, Antti Honkela, Krista Lagus,
%  Jeremias Seppa, Harri Valpola, and Paul Wagner
% 
%  This program is free software; you can redistribute it and/or modify
%  it under the terms of the GNU General Public License as published by
%  the Free Software Foundation; either version 2, or (at your option)
%  any later version.
% 
%  This program is distributed in the hope that it will be useful,
%  but WITHOUT ANY WARRANTY; without even the implied warranty of
%  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%  GNU General Public License (included in file License.txt in the
%  program package) for more details.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


if nargin < 2, inds = State.Ind; end
if isempty(inds), cost = 0; return; end

cost = get_cost([ State.Groups(inds).Model ]);


return;
